--- Many thanks to Dennis Hafstrom for the idea (and the code) for this News frame (lifted from Enhancer)

local _G = getfenv(0)
local LibStub = _G["LibStub"]
local L = LibStub("AceLocale-3.0"):GetLocale("ShockAndAwe")

local format, len = _G.string.format, _G.string.len
local gsub, trim = _G.string.gsub, _G.strtrim

ShockAndAwe.newsCurrent = 2 -- Can only ever increase

function ShockAndAwe:AddNewsStory(article)
		ShockAndAwe.newsFrame:AddLine("Introduction", "Welcome to ShockAndAwe and Enhancement Shammy max dps addon. ")
		ShockAndAwe.newsFrame:AddLine("", "This addon was written to enhance Enhancement shamans dps and build on the")
		ShockAndAwe.newsFrame:AddLine("", "work done with DisqoDice. Its aim is to provide a fully configurable addon you")
		ShockAndAwe.newsFrame:AddLine("", "can adjust to suit your own particular UI layout. Use /saa config to access")
		ShockAndAwe.newsFrame:AddLine("", "the configuration menu")
		ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
		ShockAndAwe.newsFrame:AddLine("Timer Bars", "There are bars for Maelstrom Weapon, Shocks, Shields, Stormstrike,")
		ShockAndAwe.newsFrame:AddLine("", "Windfury, Lava Lash and Global cooldown. You can change their colours, textures, ")
		ShockAndAwe.newsFrame:AddLine("", "scale the frame and change its width in the config options. As well as turning")
		ShockAndAwe.newsFrame:AddLine("", "them on or off. You can also configure the Maelstrom sounds to play on 4 and 5 stacks")
		ShockAndAwe.newsFrame:AddLine("", ", as well as configuring the maelstrom bar to flash when 5 stacks are achieved.")
		ShockAndAwe.newsFrame:AddLine("", "If you wish you can also configure the bars to hide when out of combat, ")
		ShockAndAwe.newsFrame:AddLine("", "and you can display icons next to each bar to help you remember which is which.")
		ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
		ShockAndAwe.newsFrame:AddLine("Priority Frame", "The priority frame comes with default configuration options. You can")
		ShockAndAwe.newsFrame:AddLine("", "change these to whatever priority of skills you want to use. The default is set to use")
		ShockAndAwe.newsFrame:AddLine("", "Lightning bolt on 5 maelstrom, StormStrike, Earth Shock, Lava Lash, You can also")
		ShockAndAwe.newsFrame:AddLine("", "turn on and off the ability to show Shamanistic rage on low mana, and availability")
		ShockAndAwe.newsFrame:AddLine("", "of your feral spirits. You can also choose to display the maelstrom weapon stacks as")
		ShockAndAwe.newsFrame:AddLine("", "'combo points' on the priority frame.")
		ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
		ShockAndAwe.newsFrame:AddLine("Uptime Frame", "The optional uptime frame will show you the percentage uptime each of your")
		ShockAndAwe.newsFrame:AddLine("", "main buffs was present for. This shows your data since last login/reload and the data")
		ShockAndAwe.newsFrame:AddLine("", "from the last fight. There is a reset session button to clear data so far this session.")
		ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
		ShockAndAwe.newsFrame:AddLine("Export to Sim", "You can use the /saa export command to export your paper doll stats")
		ShockAndAwe.newsFrame:AddLine("", "to the EnhSim enhancement shammy simulator which is available for download at")
		ShockAndAwe.newsFrame:AddLine("", "http://code.google.com/p/enhsim/downloads/list")
		ShockAndAwe.newsFrame:AddLine("", "To use this open the config.txt file from EnhSim in wordpad or similar editor (notepad")
		ShockAndAwe.newsFrame:AddLine("", "doesn't work) and find the section at the end of the config file which tells you to" )
		ShockAndAwe.newsFrame:AddLine("", "replace that data with the data pasted from ShockAndAwe. Once you delete the old ")
		ShockAndAwe.newsFrame:AddLine("", "data switch to WoW and simply type /saa export and press ctrl-c when the frame opens,")
		ShockAndAwe.newsFrame:AddLine("", "then go back to your text editor and paste the data into the file at the end. Save")
		ShockAndAwe.newsFrame:AddLine("", "this new config file eg: I use Levva.txt and the run the sim. Use EnhSimGUI.exe if")
		ShockAndAwe.newsFrame:AddLine("", "you want to change other things like buffs etc. as its visual display of the settings")
		ShockAndAwe.newsFrame:AddLine("", "is easier to use if you are not sure what to do. The Simulate button will give your")
		ShockAndAwe.newsFrame:AddLine("", "expected DPS and the Calculate EP values button will calculate what stats eg:AP/Crit")
		ShockAndAwe.newsFrame:AddLine("", "to look for when you get new gear. Higher the number the more you need that stat.")
		ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
		ShockAndAwe.newsFrame:AddLine("Keybindings", "You can also use ShockAndAwe to keybind your Water Shield and Lightning")
		ShockAndAwe.newsFrame:AddLine("", "Shields, as well as keybinding your main and off hand weapon buffs.")
		ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
		ShockAndAwe.newsFrame:AddLine("General","Windfury & Stormstrike cumulative totals can be shown in Scrolling Combat text")
		ShockAndAwe.newsFrame:AddLine("","or in a default warning frame. ")
		ShockAndAwe.newsFrame:AddLine("","All of the frames in ShockAndAwe can be moved using /saa moveframes")
		ShockAndAwe.newsFrame:AddLine("","There are dozens and dozens of configurable options in ShockAndAwe use /saa config")
		ShockAndAwe.newsFrame:AddLine("","to view them all")
		ShockAndAwe.newsFrame:AddLine("","ShockAndAwe can warn you if you enter combat without your weapon buffs, it can also")
		ShockAndAwe.newsFrame:AddLine("","be configured to warn you when your shield and weapon buffs expire.")
		ShockAndAwe.newsFrame:AddLine("","You can view this news at any time by typing /saa news")
		ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
		ShockAndAwe.newsFrame:AddLine("Bugs", "Please also report any bugs you find to the website below. However before you")
		ShockAndAwe.newsFrame:AddLine("", "post a bug report PLEASE do a /saa version and quote the full version number.")
		ShockAndAwe.newsFrame:AddLine("", "When you post a bug. A report without a version number is practically useless.")
end

function ShockAndAwe:News(override)
	if (not override and ((self.db.char.newsitem or 0) >= self.newsCurrent)) then return; end
	self:CreateNewsFrame()
	
	ShockAndAwe.newsFrame:Clear()
	ShockAndAwe.newsFrame.title:SetText("|cffffd200ShockAndAwe|r")
	
	self:AddNewsStory(self.db.char.newsitem)
	
	-------- max length for "subject    ","body"---------------------------------------------------
	ShockAndAwe.newsFrame:AddLine("            ","") -- Some spacing
	ShockAndAwe.newsFrame:AddLine("            ","")
	
	ShockAndAwe.newsFrame:AddLine(L["Config"], L["help1"])
	ShockAndAwe.newsFrame:AddLine("", L["help2"])
	ShockAndAwe.newsFrame:AddLine("", L["help_command"])
	ShockAndAwe.newsFrame:AddLine("            ","")
	ShockAndAwe.newsFrame:AddLine(L["Website"], self:SpamSafe(L["__URL__"]))
	
	-- do return; end
	ShockAndAwe.newsFrame:Show()
	self.db.char.newsitem = self.newsCurrent
end

function ShockAndAwe:SpamSafe(text)
	-- replace ' [dot] ' with '.' and ' [at] ' with '@'
	return gsub(gsub(text, " %[at%] ", "@"), " %[dot%] ", ".")
end

function ShockAndAwe:CreateNewsFrame()
	ShockAndAwe.newsFrame = CreateFrame("Frame", "AddOnNewsFrame", UIParent, "DialogBoxFrame")
	ShockAndAwe.newsFrame:SetWidth(520)
	ShockAndAwe.newsFrame:SetHeight(400)
	ShockAndAwe.newsFrame:SetPoint("CENTER")
	ShockAndAwe.newsFrame:SetBackdrop({
		bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
	    edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	    tile = true, tileSize = 16, edgeSize = 16,
	    insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
	ShockAndAwe.newsFrame:SetBackdropColor(0,0,0,1)
	
	local text = ShockAndAwe.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLarge")
	text:SetFont([[Interface\AddOns\ShockAndAwe\fonts\CAS_ANTN.TTF]], 24, "OUTLINE") -- http://wdnaddons.com/2307561/FrameXML/Fonts.xml
	ShockAndAwe.newsFrame.title = text
	text:SetPoint("TOP", 0, -5)

	ShockAndAwe.newsFrame:Hide()

	ShockAndAwe.newsFrame.lefts = {}
	ShockAndAwe.newsFrame.rights = {}
	ShockAndAwe.newsFrame.textLefts = {}
	ShockAndAwe.newsFrame.textRights = {}
	function ShockAndAwe.newsFrame:Clear()
		self.title:SetText("")
		self.disclaimer:SetText("")
		for i = 1, #self.lefts do
			self.lefts[i] = nil
			self.rights[i] = nil
		end
	end
	
	local function rightColor(right)
		-- Email color as link
		right = gsub(right, "[A-Za-z0-9%.%%%+%-]+@[A-Za-z0-9%.%%%+%-]+%.%w%w%w?%w?", function(v) return "|cff007fff"..v.."|r"; end)
		
		-- URL color as link (is crap need better URL matching)
		right = gsub(right, "http%:%/%/[A-Za-z0-9%.%/%-]+", function(v) return "|cff007fff"..v.."|r"; end)
		
		-- '-quoted color gray
		right = gsub(right, "(%')(%/%w-%s?%w-)(%')", function(v1, v2, v3) return v1.."|cffcccccc"..v2.."|r"..v3; end) --00ff7f
		
		-- *) lists
		right = gsub(right, "^(%*%)%s)(.+)", function(v1, v2) return "|cff00cccc"..v1.."|r"..v2; end)
		
		-- return the mess
		return right
	end

	function ShockAndAwe.newsFrame:AddLine(left, right)
		ShockAndAwe.newsFrame.lefts[#ShockAndAwe.newsFrame.lefts+1] = trim(left)
		ShockAndAwe.newsFrame.rights[#ShockAndAwe.newsFrame.rights+1] = rightColor(trim(right))
	end

	local newsFrame_Show = ShockAndAwe.newsFrame.Show
	function ShockAndAwe.newsFrame:Show(...)
		local maxLeftWidth = 0
		local maxRightWidth = 0
		local textHeight = 0
		for i = 1, #self.lefts do
			if not self.textLefts[i] then
				local left = ShockAndAwe.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				left:SetFont([[Interface\AddOns\ShockAndAwe\fonts\CAS_ANTN.TTF]], 16, "OUTLINE")
				self.textLefts[i] = left
				local right = ShockAndAwe.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
				right:SetFont([[Interface\AddOns\ShockAndAwe\fonts\Cella.ttf]], 14, "OUTLINE")
				self.textRights[i] = right
				if i == 1 then
					left:SetPoint("TOPRIGHT", ShockAndAwe.newsFrame, "TOPLEFT", 130, -35)
				else
					left:SetPoint("TOPRIGHT", self.textLefts[i-1], "BOTTOMRIGHT", 0, -1)
				end
				right:SetPoint("LEFT", left, "RIGHT", 5, 0)
			end
			self.textLefts[i]:SetText(self.lefts[i] .. ((len(self.lefts[i]) > 0 and len(strtrim(self.lefts[i])) > 0 and ":") or " "))
			self.textRights[i]:SetText(self.rights[i])
			local leftWidth = self.textLefts[i]:GetWidth()
			local rightWidth = self.textRights[i]:GetWidth()
			textHeight = self.textLefts[i]:GetHeight()
			if maxLeftWidth < leftWidth then
				maxLeftWidth = leftWidth
			end
			if maxRightWidth < rightWidth then
				maxRightWidth = rightWidth
			end
		end
		for i = #self.lefts+1, #self.textLefts do
			self.textLefts[i]:SetText('')
			self.textRights[i]:SetText('')
		end
		local finalWidth = maxLeftWidth + maxRightWidth + 10
		if (finalWidth < 360) then finalWidth = 360; end
		ShockAndAwe.newsFrame:SetWidth(finalWidth)
		ShockAndAwe.newsFrame:SetHeight(#self.lefts * (textHeight + 1) + 100)

		newsFrame_Show(self, ...)
	end
	ShockAndAwe.newsFrame:Hide()
	
	local disclaimer = ShockAndAwe.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	disclaimer:SetFont([[Interface\AddOns\ShockAndAwe\fonts\Cella.ttf]], 8, "")
	ShockAndAwe.newsFrame.disclaimer = disclaimer
	disclaimer:SetPoint("BOTTOMRIGHT", ShockAndAwe.newsFrame:GetName(), "BOTTOMRIGHT", -5, 5)
	
	ShockAndAwe.CreateNewsFrame = function() return; end;
end